"""
Django settings for pomaire project.

Generated by 'django-admin startproject' using Django 2.2.5.

For more information on this file, see
https://docs.djangoproject.com/en/2.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.2/ref/settings/
"""

import os
from os.path import dirname, abspath, join
from datetime import timedelta
import sentry_sdk
from sentry_sdk.integrations.django import DjangoIntegration
from multifiberpy.sentry_multifiber import send_slack_event

from pathlib import Path
from dotenv import load_dotenv
from . import get_env_variable
import secrets

env_path = Path('.') / '.env'
load_dotenv(dotenv_path=env_path)

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = dirname(dirname(dirname(abspath(__file__))))
BASE_DIR_LOG = os.path.join(dirname(BASE_DIR), 'logs')
SECRET_KEY = get_env_variable('SECRET_KEY')


sentry_sdk.init(
    dsn=get_env_variable('DSN'),
    integrations=[DjangoIntegration()],
    before_send=send_slack_event
)

#print(get_env_variable('DSN'))
# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = False

ALLOWED_HOSTS = ['pagos.bandaancha.cl','pagos.gigainternet.cl','fibertel.cl','pagos.optic.cl','149.28.109.212', 'pomaire7.cl']

WEBPAY = get_env_variable('SHOW_WEBPAY')

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'rest_framework',
    'rest_framework_jwt', 
    'rest_framework_swagger', 
    'simple_history', 
    'corsheaders',
    'khipu',
    'webpay',
    'paypal',
    'common',
    'dynamic_preferences',
    'dynamic_preferences.users.apps.UserPreferencesConfig',
    'import_export',
    'url_filter',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    # 'csp.middleware.CSPMiddleware',
]

X_FRAME_OPTIONS = 'ALLOW-FROM 127.0.0.1:8080'


# CSP_INCLUDE_NONCE_IN = ['default-src']

ROOT_URLCONF = 'config.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'templates/')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'config.wsgi.application'

# Password validation
# https://docs.djangoproject.com/en/2.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

LOGIN_URL = '/login/'
LOGIN_REDIRECT_URL = '/'

# Internationalization
# https://docs.djangoproject.com/en/2.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = "America/Argentina/Buenos_Aires" 

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.2/howto/static-files/

STATIC_URL = '/static/'

# Django REST framework

REST_FRAMEWORK = {
    'DEFAULT_PERMISSION_CLASSES': (
        'rest_framework.permissions.AllowAny',#  IsAuthenticated
    ),
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'rest_framework_jwt.authentication.JSONWebTokenAuthentication',
    ),
    #token
    'JWT_EXPIRATION_DELTA': timedelta(hours=48),
    "JWT_ALLOW_REFRESH": True,
}

SWAGGER_SETTINGS = {
    'SECURITY_DEFINITIONS': {
        'api_key': {
            'type': 'apiKey',
            'in': 'header',
            'name': 'Authorization'
        }
    },
    'USE_SESSION_AUTH': False
}

CORS_ORIGIN_WHITELIST = [
    "http://localhost:8000",
    "http://127.0.0.1:8000",
    "https://gigainternet.cl",
    "https://multifiber.cl",
    "https://bandaancha.cl"
]

SITE_NAME = 'pomaire'

CORS_ORIGIN_ALLOW_ALL = True

DYNAMIC_PREFERENCES = {

    # a python attribute that will be added to model instances with preferences
    # override this if the default collide with one of your models attributes/fields
    'MANAGER_ATTRIBUTE': 'preferences',

    # The python module in which registered preferences will be searched within each app
    'REGISTRY_MODULE': 'preferences',

    # Allow quick editing of preferences directly in admin list view
    # WARNING: enabling this feature can cause data corruption if multiple users
    # use the same list view at the same time, see https://code.djangoproject.com/ticket/11313
    'ADMIN_ENABLE_CHANGELIST_FORM': True,

    # Customize how you can access preferences from managers. The default is to
    # separate sections and keys with two underscores. This is probably not a settings you'll
    # want to change, but it's here just in case
    'SECTION_KEY_SEPARATOR': '__',

    # Use this to disable caching of preference. This can be useful to debug things
    'ENABLE_CACHE': True,
    
    # Use this to disable checking preferences names. This can be useful to debug things
    'VALIDATE_NAMES': True,
}

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql_psycopg2',
        'NAME':  get_env_variable('DB_NAME'),
        'USER': get_env_variable('DB_USER'),
        'PASSWORD': get_env_variable('PASSWORD_DB'),
        'HOST': get_env_variable('DB_HOST'),
        'PORT': get_env_variable('DB_PORT', 5432),
    }
}

# WEBPAY CREDENTIALS
TBK_ENV=secrets.TBK_ENV
GIGA_TBK_CERT_DATA = secrets.GIGA_TBK_CERT_DATA
GIGA_KEY_DATA = secrets.GIGA_KEY_DATA
GIGA_CERT_DATA = secrets.GIGA_CERT_DATA

BANDA_TBK_CERT_DATA = secrets.BANDA_TBK_CERT_DATA
BANDA_KEY_DATA = secrets.BANDA_KEY_DATA
BANDA_CERT_DATA = secrets.BANDA_CERT_DATA

MATRIX_URL=secrets.MATRIX_URL

BCC_USER = secrets.BCC_USER
BCC_PASSWD = secrets.BCC_PASSWD